<?php
/*
NOTICE OF LICENSE

This source file is subject to the NekloEULA that is bundled with this package in the file ICENSE.txt.

It is also available through the world-wide-web at this URL: http://store.neklo.com/LICENSE.txt

Copyright (c)  Neklo (http://store.neklo.com/)
*/


namespace Neklo\Scheduler\Controller\Adminhtml\Schedule;

use Neklo\Scheduler\Controller\Adminhtml;
use Neklo\Scheduler\Api\Data\ScheduleInterface;

class Delete extends Adminhtml\Operation
{
    public function execute()
    {
        try {
            $data = $this->getRequest()->getParam(ScheduleInterface::SCHEDULE_ID);
            if ($data) {
                /** @var $model \Magento\Cron\Model\Schedule */
                $model = $this->_objectManager->create('Magento\Cron\Model\Schedule');
                $model->load($data);
                if ($model->getId()) {
                    $name = $model->getJobCode();
                    $time = $model->getScheduledAt();
                    $model->delete();
                    $this->messageManager->addSuccess(
                        __('Schedule %1 at %2 removed', $name, $time)
                    );
                }
            } else {
                $this->messageManager->addError(__('Data ID missing - error'));
            }
        } catch (\Exception $e) {
            $this->logger->critical($e->getMessage());
            $this->messageManager->addError(__('Operation error'));
        }

        return $this->_redirect(static::REDIRECT_URL);
    }
}
